//	musicdriver.c
//--------------------------------------------------------------
//
//	MusicDriver Test Ver0.01
//
//			Apr21,2003 MAGiC TOUCH / and@big.or.jp
//						http://www10.big.or.jp/~and/
//
// ht9̉QlɂĂĂ܂B
//--------------------------------------------------------------

#include "gba.h"

#include "sound.h"
#include "MusicDriver.h"
#include "utility.h"
#include "data.h"

//--------------------------------------------------------------------
void IRQ_MusicDriverHandler();
void KeyOff(int track);
void CommandCheck(int track);
void SetPan();

void Sound1Reset();
void Sound1(u16 freq);
void Sound2Reset();
void Sound2(u16 freq);
void Sound3Reset();
void Sound3(u16 freq);
void Sound4Reset();
void Sound4(u16 freq);

//--------------------------------------------------------------------
// eXgȂŁA荞ݎԌŒiƂłȂj
#define	INTERUPT_TIMER	(65535-530)

#define TM_FREQ_PER_256	(1<<1)
#define TM_USEIRQ		(1<<6)
#define TM_ENABLE		(1<<7)

//--------------------------------------------------------------------
// play frequency data / f[^
// ROM
const u16 FreqData[]=
{//	   C	  C+	   D	  D+	   E	   F	  F+	   G	  G+	   A	  A+	   B
	  44,	 156,	 262,	 363,	 457,	 547,	 631,	 710,	 786,	 854,	 923,	 986,	// o2
	1046,	1102,	1155,	1205,	1253,	1297,	1339,	1379,	1417,	1452,	1486,	1517,	// o3
	1546,	1575,	1602,	1627,	1650,	1673,	1694,	1714,	1732,	1750,	1767,	1783,	// o4
	1798,	1812,	1825,	1837,	1849,	1860,	1871,	1881,	1890,	1899,	1907,	1915,	// o5
	1923,	1930,	1936,	1943,	1949,	1954,	1959,	1964,	1969,	1974,	1978,	1982,	// o6
	1985,	1988,	1992,	1995,	1998,	2001,	2004,	2006,	2009,	2011,	2013,	2015,	// o7
};

//--------------------------------------------------------------------
static MusicDriverStatus	MDS;

//--------------------------------------------------------------------
// driver status / O烏[NQƂƂɎg
volatile MusicDriverStatus *GetDriver()
{
	return( (volatile MusicDriverStatus*)&MDS);
}


//--------------------------------------------------------------------
// 荞݃nh
void IRQ_Handler()
{
	volatile u16 Int_Flag;

	REG_IME = IRQ_MASTER_OFF;			// ق̕@肻Ȃ̂ŁA
	Int_Flag = REG_IF;					// ̊荞ݕƖoȂ񂾂EEE

	if((REG_IF & IRQ_BIT_TIMER3))
	{
		REG_TM3D =INTERUPT_TIMER;		// ̃^C}[̐ݒ
		MD_DriverMain();				// 荞݃C
	}

	REG_IF = Int_Flag;					// tOޕA
	REG_IME = IRQ_MASTER_ON;
}

//--------------------------------------------------------------------
// 荞ݏ
void IRQ_MusicDriverStart()
{
	REG_IME = IRQ_MASTER_OFF;								// ܂͊荞݂֎~

	REG_INTERUPT = (u32)IRQ_Handler;						// 荞݂̃AhX̐ݒ
	REG_IE |= IRQ_BIT_TIMER3;								// Timer3 荞݂gpɐݒ
	
	REG_TM3D = INTERUPT_TIMER;								// 荞݋
	REG_TM3CNT = TM_FREQ_PER_256 | TM_USEIRQ | TM_ENABLE ;	// 256ClockŊ荞

	REG_IME = IRQ_MASTER_ON;								// 荞݊Jn
}

//--------------------------------------------------------------------
void MD_Init(void)
{
	REG_SGCNT1 = ALL_SOUND_ENABLE;
	
	// mo͂ɏ
	REG_SGCNT0_L =
	( 
		DMG_LEFT_VOLUME(6) | DMG_RIGHT_VOLUME(6) |
		SOUND1_LEFT_OUTPUT | SOUND1_RIGHT_OUTPUT |
		SOUND2_LEFT_OUTPUT | SOUND2_RIGHT_OUTPUT |
		SOUND3_LEFT_OUTPUT | SOUND3_RIGHT_OUTPUT |
		SOUND4_LEFT_OUTPUT | SOUND4_RIGHT_OUTPUT
	);

	REG_SGCNT0_H = 2;//SOUND_OUTPUT_RATIO(2);

	// ʓ|Ȃ̂łĂ
	MD_Play(0);
}

//--------------------------------------------------------------------
void SetPan()
{
	// pݒE蔲B
	// todo:XɃ}XN悤ɕύX悤ɁEEE
	REG_SGCNT0_L =
	( 
		  DMG_LEFT_VOLUME(6) | DMG_RIGHT_VOLUME(6)
		| ((MDS.m_TrackStatus[0].m_Pan & 0x02) <<  7) | ((MDS.m_TrackStatus[0].m_Pan & 0x01) << 12)
		| ((MDS.m_TrackStatus[1].m_Pan & 0x02) <<  8) | ((MDS.m_TrackStatus[1].m_Pan & 0x01) << 13)
		| ((MDS.m_TrackStatus[2].m_Pan & 0x02) <<  9) | ((MDS.m_TrackStatus[2].m_Pan & 0x01) << 14)
		| ((MDS.m_TrackStatus[3].m_Pan & 0x02) << 10) | ((MDS.m_TrackStatus[3].m_Pan & 0x01) << 15)
	);
}


//--------------------------------------------------------------------
void Sound1Reset()
{

	MDS.m_Env[0].EnvelopeInitialVolume=0;
	REG_SG10_H = *(u16*)&MDS.m_Env[0];

	REG_SG11 =	SOUND1_FREQ(0) | SOUND1_CONTINUE | SOUND1_RESET ;																							// NR13.14
}

//-----------------
void Sound1(u16 freq)
{

	// Sweepނ͌ݖ
	// KvȂƂݒł͂B
	REG_SG10_L = (SOUND1_SWEEP_SHIFT(0) | SOUND1_SWEEP_DEC | SOUND1_SWEEP_TIME(0) );	// NR10


	// b
	MDS.m_Env[0].EnvelopeInitialVolume=MDS.m_TrackStatus[0].m_Volume;
	REG_SG10_H = *(u16*)&MDS.m_Env[0];

	REG_SG11 =	SOUND1_FREQ(freq) | SOUND1_CONTINUE | SOUND1_RESET ;																							// NR13.14

}

//--------------------------------------------------------------------
void Sound2Reset()
{
	MDS.m_Env[1].EnvelopeInitialVolume=0;

	// b
	REG_SG20 =*(u16*)&MDS.m_Env[1];
	REG_SG21 =( SOUND2_FREQ(0) | SOUND2_CONTINUE | SOUND2_RESET);


}

//-----------------
void Sound2(u16 freq)
{
	MDS.m_Env[1].EnvelopeInitialVolume=MDS.m_TrackStatus[1].m_Volume;

	REG_SG20 =*(u16*)&MDS.m_Env[1];
	REG_SG21 =(	SOUND2_FREQ(freq) | SOUND2_CONTINUE | SOUND2_RESET );

}

//--------------------------------------------------------------------
void Sound3Reset()
{
	//REG_SG31 = (SOUND3_FREQ(freq) | SOUND3_CONTINUE | SOUND3_RESET);
	REG_SG30_L &= ~SOUND3_OUTPUT_ENABLE;
}

//-----------------
void Sound3(u16 freq)
{
	// FZbgł悢̂EEE
	// OpghL
	REG_SGWR0 = 0x2064A8EC;
	REG_SGWR1 = 0xDF9B5713;
	REG_SGWR2 = 0x2064A8EC;
	REG_SGWR3 = 0xDF9B5713;

	// ƂŁAR}hwł悤ɕύX
	REG_SG30_L = ( SOUND3_BANK_2x32 | SOUND3_BANK_SELECT(1) | SOUND3_OUTPUT_ENABLE );
	REG_SG30_H = ( SOUND3_LENGTH(8) | SOUND3_VOLUME_RATIO(7) );
	
	REG_SG31 = (SOUND3_FREQ(freq) | SOUND3_CONTINUE | SOUND3_RESET);

}

//--------------------------------------------------------------------
void Sound4Reset()
{
	// REG_SOUND4CNT_L=(envinit<<12)+(envdir<<11)+(envsteptime<<8)+soundlength;
	// REG_SOUND4CNT_H=SOUND4INIT+(loopmode<<14)+(shift_freq<<4)+(stepping<<3)+freq_ratio;
	REG_SG40 =( SOUND4_LENGTH(0) | 	SOUND4_ENVELOP_STEP(1) | SOUND4_ENVELOP_DEC | SOUND4_ENVELOP_VALUE(0));
	REG_SG41 =( SOUND4_RESET | SOUND4_CONTINUE |  SOUND4_STAGE_7 | SOUND4_STAGE_FREQ(5) | SOUND4_DIVIDE_FREQ(0));
}


//-----------------
void Sound4(u16 freq)
{
	//Sound4Reset();
	u16	note;
	if (freq==44){note=7;}else{note=3;};		// eXgȂŁAŒliŒ̖YȂ[j


	REG_SG40 =( SOUND4_LENGTH(0) | 	SOUND4_ENVELOP_STEP(1) | SOUND4_ENVELOP_DEC | SOUND4_ENVELOP_VALUE(10));
	REG_SG41 =( SOUND4_RESET | SOUND4_CONTINUE |  SOUND4_STAGE_7 | SOUND4_STAGE_FREQ(5) | SOUND4_DIVIDE_FREQ(note)  );
}

//---------------------------------------------------------------------------------------------------
//
//	void InitTrack(int track,const SCode* addr,BOOL isUse)
//
//			f[^tɐ삯Ẵ[Nނ̏
//			Channel 1̈ꕔ3/4  
//
//---------------------------------------------------------------------------------------------------
void InitTrack(int track,const SCode* addr,BOOL isUse)
{
	MDS.m_TrackStatus[track].m_pCodeTop		= (SCode* )addr;
	MDS.m_TrackStatus[track].m_CurrentData	= *MDS.m_TrackStatus[track].m_pCodeTop;
	MDS.m_TrackStatus[track].m_IsUse		= isUse;
	MDS.m_TrackStatus[track].m_Detune		= 0;
	MDS.m_TrackStatus[track].m_LFO_work		= 0;
	MDS.m_TrackStatus[track].m_DataPos		= 0;
	MDS.m_TrackStatus[track].m_Gate			= 16;
	MDS.m_TrackStatus[track].m_GateWork		= 0;
	MDS.m_TrackStatus[track].m_Pan			= 3;
	MDS.m_TrackStatus[track].m_Volume		= 12;

	if (track<2)
	{
		MDS.m_Env[track].SoundLength = 0;
		MDS.m_Env[track].WevPatternDuty=0;
		MDS.m_Env[track].EnvelopeStepTime=0;			// 0-7
		MDS.m_Env[track].EnvelopeDirection=0;			// 0,1
		MDS.m_Env[track].EnvelopeInitialVolume=0;		// 0-15
	}

	// Ô
	KeyOff(track);

}

//---------------------------------------------------------------------------------------------------
//
//	void MD_Play(int num)
//
//			num ŋȔԍw肷悤ɁB
//
//			񂺂łĂւ
//
//---------------------------------------------------------------------------------------------------
void MD_Play(int num)
{
	int	i;

	//---------------------------------------------------------------------------------
	// egbNĂ݂
	//		todo:f[^玩ŏ悤ɕύXB
	InitTrack(0,NoteData1,TRUE);
	InitTrack(1,NoteData2,TRUE);
	InitTrack(2,NoteData3,TRUE);
	InitTrack(3,NoteData4,TRUE);

	// egbN̏
	for(i=0; i<TRACK_MAX; i++)
	{
		//---------------------------------------------------------------------------------
		// ̃gbNgp邩mF
		if (!MDS.m_TrackStatus[i].m_IsUse)
		{
			// gpȂ̂Ŏ̃gbN
			continue;
		}

		// Note,Length̎擾
		MDS.m_TrackStatus[i].m_CurrentData = MDS.m_TrackStatus[i].m_pCodeTop[MDS.m_TrackStatus[i].m_DataPos];
		CommandCheck(i);
	}
}

//--------------------------------------------------------------------
//	ƌ̂ŁAƂŕύX悤ɁB
void KeyOn(int track,int freq)
{
	switch(track)
	{
		case 0:
			Sound1(freq);
			break;

		case 1:
			Sound2(freq);
			break;

		case 2:
			Sound3(freq);
			break;

		case 3:
			Sound4(freq);
			break;
	}
}

//--------------------------------------------------------------------
//	ƌ̂ŁAƂŕύX悤ɁB
void KeyOff(int track)
{
	switch(track)
	{
		case 0:
			Sound1Reset();
			break;

		case 1:
			Sound2Reset();
			break;

		case 2:
			Sound3Reset();
			break;

		case 3:
			Sound4Reset();
			break;
	}
}


//---------------------------------------------------------------------------------------------------
//
//	void MD_DriverMain()
//
//			hCo[C
//
//			񂺂R}hB荞݂œ񂾂ǁAł񂩁H
//
//---------------------------------------------------------------------------------------------------
void MD_DriverMain()
{
	int	track;

	for(track=0; track<TRACK_MAX; track++)
	{
		//---------------------------------------------------------------------------------
		// ̃gbNgp邩mF
		if (MDS.m_TrackStatus[track].m_IsUse==FALSE)
		{
			// gpȂ̂Ŏ̃gbN
			continue;
		}

		//---------------------------------------------------------------------------------
		// `FbN
		MDS.m_TrackStatus[track].m_CurrentData.param--;			// lengthZ
		if (MDS.m_TrackStatus[track].m_CurrentData.param==0)
		{
			//-----------------------------
			// Ả(R}h)̏
			CommandCheck(track);
		}
		else
		{
			//-----------------------------
			// B

			// qR}h
			// bEݐĂȂ
			if (MDS.m_TrackStatus[track].m_GateWork && MDS.m_TrackStatus[track].m_GateWork>MDS.m_TrackStatus[track].m_CurrentData.param)
			{
				KeyOff(track);
				MDS.m_TrackStatus[track].m_GateWork=0;
			}

		}
	}
}


//--------------------------------------------------------------------
void CommandCheck(int track)
{
	u16 freq;
	//-----------------------------
	// R}h̎擾
	//-----------------------------

rescan:
	// ݍĐʒũR}h擾
	MDS.m_TrackStatus[track].m_CurrentData =
		MDS.m_TrackStatus[track].m_pCodeTop[MDS.m_TrackStatus[track].m_DataPos];

	//-----------------------------
	// R}ȟ
	//-----------------------------
	switch(MDS.m_TrackStatus[track].m_CurrentData.command)
	{
		case 83:// Volume
			// {EB
			MDS.m_TrackStatus[track].m_Volume =
				MDS.m_TrackStatus[track].m_CurrentData.param;

			MDS.m_TrackStatus[track].m_DataPos++;
			goto rescan;
	
		case 84:// Loop
			// [vBm[gĐʒu擪ɁB
			// ̂Ƃ닭Iɐ擪ɎĂB
			MDS.m_TrackStatus[track].m_DataPos=0;
			goto rescan;

		case 79:
			// ^C#1
			// ̂܂܌p(KeyOFFȂj
			MDS.m_TrackStatus[track].m_And = TRUE;
			MDS.m_TrackStatus[track].m_DataPos++;
			goto rescan;

		case 80:
			// ^C#2
			// ̂܂܌p(KeyOFFȂj
			MDS.m_TrackStatus[track].m_DataPos++;
			break;

		case 74:// Q
			// Q[g 1`16
			MDS.m_TrackStatus[track].m_Gate = MDS.m_TrackStatus[track].m_CurrentData.param;
			MDS.m_TrackStatus[track].m_DataPos++;
			goto rescan;

		case 75:// P
			// p|bg 1..left 2..right 3..center
			MDS.m_TrackStatus[track].m_Pan = MDS.m_TrackStatus[track].m_CurrentData.param;
			MDS.m_TrackStatus[track].m_DataPos++;
			SetPan();
			goto rescan;

		case 78:// D 
			// fB`[
			MDS.m_TrackStatus[track].m_Detune = (MDS.m_TrackStatus[track].m_CurrentData.param>128)
					? MDS.m_TrackStatus[track].m_CurrentData.param-255
					: MDS.m_TrackStatus[track].m_CurrentData.param;
			MDS.m_TrackStatus[track].m_DataPos++;
			goto rescan;

		case 73:// R
			// x
			KeyOff(track);
			MDS.m_TrackStatus[track].m_DataPos++;
			break;

		default:
			// m[g擾
			MDS.m_TrackStatus[track].m_Note = MDS.m_TrackStatus[track].m_CurrentData.command;

			// Q[gݒ
			//		ꂾƃ^C̏Ƃ̂ŗvASYĈ
			MDS.m_TrackStatus[track].m_GateWork =
				MDS.m_TrackStatus[track].m_CurrentData.param * (16-MDS.m_TrackStatus[track].m_Gate)/16;

			// ^C
			// Q[gݒƂ̐H킹
			if (MDS.m_TrackStatus[track].m_And==FALSE)
			{
				KeyOff(track);
				// 
				freq = MDS.m_TrackStatus[track].m_Freq=FreqData[MDS.m_TrackStatus[track].m_CurrentData.command]		// o͉
					  + MDS.m_TrackStatus[track].m_Detune;															// DetuneZ

				// Ƃ[
				KeyOn(track,freq);
			}

			// ̃f[^
			MDS.m_TrackStatus[track].m_DataPos++;
			MDS.m_TrackStatus[track].m_And= FALSE;
			break;
	}
}

