//	musicdriver.h
//--------------------------------------------------------------
//
//	MusicDriver Test Ver0.01
//
//			Apr21,2003 MAGiC TOUCH / and@big.or.jp
//						http://www10.big.or.jp/~and/
//
//--------------------------------------------------------------

#ifndef _MUSIC_DRIVER_H_
#define _MUSIC_DRIVER_H_

//---------------------------------------------------------------------
// OɌJ
extern void IRQ_MusicDriverStart();
extern void MD_Init();
extern void MD_DriverMain();
extern void MD_Play(int num);

//---------------------------------------------------------------------
// !!
// SCodeƏX肪B
// ARM-GCC̏ꍇA\̂̃AC 8bit/32bit̂ǂ炩ɂȂĂāA
// ǂftHgł32bit炵B
// Ȃ킿APC
//    sizeof(SCode) = 2Bytes(16bit)
// Ȃ̂AGBA(ARM-GCC)
//    sizeof(SCode) = 4Bytes(32bit)
// ƂȂĂ܂āAʂ炯̃f[^ɂȂĂ܂B
// ̂ŁAx肱񂾂AύX悤ɁB_v܂
// CÂȂB悭SSSAĂȂB
//---------------------------------------------------------------------
typedef struct _Note
{
	u8 command;						// R[h
	u8 param;						// 
} SCode;



//---------------------------------------------------------------------
typedef struct _env
{
	u16	SoundLength:6;
	u16	WevPatternDuty:2;
	u16	EnvelopeStepTime:3;				// 0-7
	u16	EnvelopeDirection:1;			// 0,1
	u16	EnvelopeInitialVolume:4;		// 0-15
} Env;


//---------------------------------------------------------------------
// yf[^̃wb_
typedef struct
{
	u8	m_ID[4];			// 0x00 ID='ANDRIVER'
	u16	m_Version;			// 0x04 0x0001->Ver0.01 / 0x0100	-> Ver1.00	
	u16	m_Offset[6];		// 0x06 egbN̐擪̈ʒu,0̏ꍇɂ́ÃgbNgp
	u8	m_Reserve[14];		// 0x18 ` 0x1F
} SoundDataHeader;

//---------------------------------------------------------------------
// egbÑXe[^X
typedef struct _TrackStatus
{							// ݖgp
	u8		m_IsUse;		// ̃gbNg?
	u8		m_Tone;			// F
	s8		m_Detune;		// g炵
	u8		m_Gate;			// Qxx
	u8		m_GateWork;		// Q[gp[NGA
	u8		m_Pan;			// p|bg
	s8		m_Volume;		// {E
	s8		m_VolumeWork;	// {E[N
	u8		m_LFO_size;		// LFȎ傫
	u8		m_LFO_len;		// 
	BOOL	m_And;			// ^C
	u8		m_Note;			// Note
	s8		m_LFO_work;		// [NGA
	u16		m_Offset;		// f[^擪ÃgbN̐擪f[^܂ł̃ItZbgʒu
	int		m_DataPos;		// ݂̃R[hʒu
	u16		m_Freq;			// g
	SCode	m_CurrentData;	// ݂̃R[h
	SCode	*m_pCodeTop;	// gbNf[^̊i[ʒu
} TrackStatus;

// hCo[̃Xe[^X
typedef struct _DriverStatus
{
	u8			m_IsUse;			// hCo[gH
	TrackStatus	m_TrackStatus[6];	// egbÑXe[^X
	Env			m_Env[2];			// Track1/2pGx[uݒ
} MusicDriverStatus;

extern volatile MusicDriverStatus *GetDriver();

/* ---------- 荞ݐݒ ----------- */


// REG_INTERUPT
// 荞ݔɌĂяo֐̃AhXZbg
#define SetIRQ(x)	REG_INTERUPT = (u32)x


// REG_IME
// 荞݃}X^[

// 荞݃}X^[IAIt
#define IRQ_MASTER_ON	1
#define IRQ_MASTER_OFF	0


// REG_IE, REG_IF
// 荞݃ZbgE

// ǂ̊荞݂gpE
#define IRQ_BIT_VBLANK	(1<<0)
#define IRQ_BIT_HBLANK	(1<<1)
#define IRQ_BIT_VCOUNT	(1<<2)
#define IRQ_BIT_TIMER0	(1<<3)
#define IRQ_BIT_TIMER1	(1<<4)
#define IRQ_BIT_TIMER2	(1<<5)
#define IRQ_BIT_TIMER3	(1<<6)
#define IRQ_BIT_SERIAL	(1<<7)
#define IRQ_BIT_DMA0	(1<<8)
#define IRQ_BIT_DMA1	(1<<9)
#define IRQ_BIT_DMA2	(1<<10)
#define IRQ_BIT_DMA3	(1<<11)
#define IRQ_BIT_KEYS	(1<<12)
#define IRQ_BIT_CART	(1<<13)

// Vblank,Hblank,Vcounť݂̏
#define DSTAT_BIT_VBLANK	(1)
#define DSTAT_BIT_HBLANK	(1<<1)
#define DSTAT_BIT_VCOUNT	(1<<2)

#define DSTAT_USE_VBLANK	(1<<3)
#define DSTAT_USE_HBLANK	(1<<4)
#define DSTAT_USE_VCOUNT	(1<<5)

#define DSTAT_VCOUNT_LINE(x)	((x)<<8)

#define SOUND3BANK32		0x0000	// Use two banks of 32 steps each
#define SOUND3BANK64		0x0020	// Use one bank of 64 steps
#define SOUND3SETBANK0		0x0000	// Bank to play 0 or 1 (non set bank is written to)
#define SOUND3SETBANK1		0x0040
#define SOUND3PLAY			0x0080	// Output sound
#define SOUND3INIT			0x8000	// Makes the sound restart

#define SOUND3OUTPUT0		0x0000	// Mute output
#define SOUND3OUTPUT1		0x2000	// Output unmodified
#define SOUND3OUTPUT12		0x4000	// Output 1/2 
#define SOUND3OUTPUT14		0x6000	// Output 1/4 
#define SOUND3OUTPUT34		0x8000  // Output 3/4
#define SOUND3PLAYONCE		0x4000	// Play sound once
#define SOUND3PLAYLOOP		0x0000	// Play sound looped
#define SOUND3INIT			0x8000	// Makes the sound restart

#define REG_SOUND1CNT   *(volatile u32*)0x4000060	//sound 1
#define REG_SOUND1CNT_L *(volatile u16*)0x4000060	//
#define REG_SOUND1CNT_H *(volatile u16*)0x4000062	//
#define REG_SOUND1CNT_X *(volatile u16*)0x4000064	//

#define REG_SOUND2CNT_L *(volatile u16*)0x4000068		//sound 2 lenght & wave duty
#define REG_SOUND2CNT_H *(volatile u16*)0x400006C		//sound 2 frequency+loop+reset

#define REG_SG30       *(volatile u32*)0x4000070		//???
#define REG_SOUND3CNT  *(volatile u32*)0x4000070		//???
#define REG_SG30_L     *(volatile u16*)0x4000070		//???
#define REG_SOUND3CNT_L *(volatile u16*)0x4000070	//???
#define REG_SG30_H     *(volatile u16*)0x4000072		//???
#define REG_SOUND3CNT_H *(volatile u16*)0x4000072	//???
#define REG_SG31       *(volatile u16*)0x4000074		//???
#define REG_SOUND3CNT_X *(volatile u16*)0x4000074	//???

#define REG_SOUND4CNT_L *(volatile u16*)0x4000078		//???
#define REG_SOUND4CNT_H *(volatile u16*)0x400007C		//???

#define REG_SGCNT0     *(volatile u32*)0x4000080		
#define REG_SGCNT0_L   *(volatile u16*)0x4000080		
#define REG_SOUNDCNT   *(volatile u32*)0x4000080
#define REG_SOUNDCNT_L *(volatile u16*)0x4000080		//DMG sound control

#define REG_SGCNT0_H   *(volatile u16*)0x4000082		
#define REG_SOUNDCNT_H *(volatile u16*)0x4000082		//Direct sound control

#define REG_SGCNT1     *(volatile u16*)0x4000084		
#define REG_SOUNDCNT_X *(volatile u16*)0x4000084	    //Extended sound control

#define REG_SGBIAS     *(volatile u16*)0x4000088		
#define REG_SOUNDBIAS  *(volatile u16*)0x4000088		//bit rate+sound bias

#define REG_WAVE_RAM0  *(volatile u32*)0x4000090		//???
#define REG_SGWR0_L    *(volatile u16*)0x4000090		//???
#define REG_SGWR0_H    *(volatile u16*)0x4000092		//???
#define REG_WAVE_RAM1  *(volatile u32*)0x4000094		//???
#define REG_SGWR1_L    *(volatile u16*)0x4000094		//???
#define REG_SGWR1_H    *(volatile u16*)0x4000096		//???
#define REG_WAVE_RAM2  *(volatile u32*)0x4000098		//???
#define REG_SGWR2_L    *(volatile u16*)0x4000098		//???
#define REG_SGWR2_H    *(volatile u16*)0x400009A		//???
#define REG_WAVE_RAM3  *(volatile u32*)0x400009C		//???
#define REG_SGWR3_L    *(volatile u16*)0x400009C		//???
#define REG_SGWR3_H    *(volatile u16*)0x400009E		//???

// őgbN
#define	TRACK_MAX	4




#endif

